extends Node

var capture := AudioEffectCapture.new()
var playback: AudioStreamGeneratorPlayback

func _ready():
	var idx := AudioServer.get_bus_count()
	AudioServer.add_bus(idx)
	AudioServer.set_bus_mute(idx, true)
	AudioServer.add_bus_effect(idx, capture)

	var mic := AudioStreamPlayer.new()
	mic.stream = AudioStreamMicrophone.new()
	mic.bus = AudioServer.get_bus_name(idx)
	add_child(mic)
	mic.play()

	var player := AudioStreamPlayer.new()
	player.stream = AudioStreamGenerator.new()
	playback = player.get_stream_playback()
	add_child(player)
	player.play()

func _physics_process(_delta: float):
	var n := capture.get_frames_available()
	var recorded := capture.get_buffer(n)
	var maxval := 0.0
	for i in range(n):
		playback.push_frame(recorded[i])

	capture.clear_buffer()
